Support FFT intensity readouts in MIRRTorDrv
01/08/2016 11:13 AM - John Diamond
Category: Drivers Estimated time: 24.00 hours
Target version: Spent time: 15.50 hours
Description

Ning has implemented support for calculating beam intensity from an FFT of the pulse data in the MIRRTor digitizer firmware.
Implement support in the driver as well as ACNET devices and CLI commands for accessing the FFT data and manipulating the
intensity calculation parameters.

History

#1 - 01/08/2016 11:44 AM - John Diamond
- File 125MHz_Digitizer_Firmware_Description_ABBO06.pdf added
- File ideal_pulse_5us_fft.txt added

Attaching the documentation for Ning's new firmware as well as data for an ideal 5us pulse.
#2 - 01/08/2016 12:03 PM - John Diamond
Ning's description of the FFT operation:

For this part, the raw data is filtered with a 4-tap moving average and decimated by 4 (resulting sampling rate of 31.25MHz). Then a 1024 point FFT is
performed and saved in the memory (A32 space).

The calculations needed from your end are the following (also in the description):

S = FFT Scaling Factor (Read from register)

F(n) = FFT Data, read from memory, index start from 0 to 1023

Fl = FFT Data of an ideal pulse, saved as txt file, index start from 0 to 1023

Pulse current reading =Y (F(n)*2-S)*Fl),3<n <511

Here we don’t exactly have to add all the way up to sample 511, perhaps Nathan can add some details as for how many points would be the best.
For the MI beam which doesn’t vary in width, this should be enough.

For PXIE which may have variable pulse width, | also added a register that counts the Gate input pulse. We had discussed about having a pulse
that’s exactly the same length as beam pulse, as a reference gate. | think that can be utilized here to calculate the intensity for a variable pulse. We
can discuss later a more elaborate

G = Gate size (length of the Gate pulse input which is in sync with beam pulse)

[ FFT of ideal pulse will have to be calculated on the fly first.]

[ Then perform the calculation described above. ]
Pulse Intensity reading = Pulse current reading * G

#3 -01/08/2016 01:10 PM - John Diamond

Implemented methods in MirrTorDrv for accessing FFT data (::fftReadout), loading the ideal pulse (::fftLoadldeal) and calculating intensity
(::fftIntensityGet).

Need CLI support for loading the ideal pulse from a file and ACNET support for reading the FFT intensity...

#4 - 01/13/2016 10:15 PM - John Diamond
- Category set to Drivers

- % Done changed from 0 to 60

Implemented CLI command (vmeintFFTConfig) for loading the ideal pulse data from file.
#5 - 01/14/2016 12:58 PM - John Diamond
- % Done changed from 60 to 70

Created a data directory for storing the ideal pulse data file:

/fecode-bd/vxworks_write/fe/vmeint
/fecode-bd/vxworks_write/fe/vmeint/nbeam

Decided to store the data in the top-level. Placed ideal_pulse_5us_fft in vmeint.

Had Denise give nbeam NFS permissions to mount as /data.

Fixed some bugs in vmeintFFTConfig(..).

Configured two toroid devices on nbeam for FFT calculations with ideal_pulse_5us_fft, start = 3 and n =32.

#6 - 01/14/2016 05:00 PM - John Diamond
- % Done changed from 70 to 80

Implemented vmeintDAQSourceSelect command.
This command can be used to select the default or FFT source/method for reading intensity from the digitizer.
Next step is to make this an ACNET control property on R:DCCT as well.

#7 - 01/15/2016 01:39 PM - John Diamond
- Status changed from Assigned to Closed

- % Done changed from 80 to 100

Created a digitial status and control property for ZZTOR990 that allows the user to select between the default intensity and the FFT intensity.
Created Z:FFT990, an ACNET array device, for reading the FFT samples for Z:TOR990.

The front end software implementation of the FFT support is complete. Will need to prove the method with Aisha/Nathan/Ning and refine for
variable-batch lengths. This ticket will be closed and 11373-fft will be merged into mirrtor_master.

Files
ideal_pulse_5us_fft.txt 18 KB 01/08/2016 John Diamond
